SystemOrganization addCategory: #MathsOntologie!

!SmallInteger methodsFor: '*MathsOntologie' stamp: 'AlainBusser 10/27/2012 14:38'!
troisChiffresDnominateur

	| units answer |

	self = 0 siVrai: [^''].
	units := #('un' 'deux' 'trois' 'quatr' 'cinqu' 'six' 'sept' 'huit' 'neuv' 'dix' 
		'onz' 'douz' 'treiz' 'quatorz' 'quinz' 'seiz' 'dix-sept' 
		'dix-huit' 'dix-neuv').
	self > 99 siVrai: [
		self > 199 siVrai: [
		answer := (units at: self // 100),' cents'.
		] siFaux: [
		answer := 'cent'
		].
		(self \\ 100) = 0 ifFalse: [
			answer := answer,' ',(self \\ 100) troisChiffresEnNom
		].
		^answer
	].
	self < 20 ifTrue: [
		^units at: self
	].
	self < 60 siVrai: [
		(self \\ 10) =0 siVrai: [
			answer := #('vingt' 'trent' 'quarant' 'cinquant') en: self // 10 -1.
			] siFaux: [
	answer := #('vingt' 'trente' 'quarante' 'cinquante')
			at: self // 10 - 1.
			].
	(self \\ 10) = 0 ifFalse: [
		(self  \\ 10) = 1 siVrai: [
			answer := answer,'-et-un'.
			] siFaux: [
		answer := answer,'-',(units at: self \\ 10)
		].
	].
	] siFaux: [
	answer := #('soixante' 'quatre-vingt') en: self // 20 - 2.
	(self \\ 20) = 0 siFaux: [
		(self  \\ 10) = 1 siVrai: [
			answer := answer,'-et-',(units en: self \\ 20).
			] siFaux: [
		answer := answer,'-',(units en: self \\ 20)].
	].
	].
	^answer! !

!SmallInteger methodsFor: '*MathsOntologie' stamp: 'AlainBusser 10/26/2012 21:07'!
troisChiffresEnNom

	| units answer |

	self = 0 siVrai: [^''].
	units := #('un' 'deux' 'trois' 'quatre' 'cinq' 'six' 'sept' 'huit' 'neuf' 'dix' 
		'onze' 'douze' 'treize' 'quatorze' 'quinze' 'seize' 'dix-sept' 
		'dix-huit' 'dix-neuf').
	self > 99 siVrai: [
		self > 199 siVrai: [
		answer := (units at: self // 100),' cents'.
		] siFaux: [
		answer := 'cent'
		].
		(self \\ 100) = 0 ifFalse: [
			answer := answer,' ',(self \\ 100) troisChiffresEnNom
		].
		^answer
	].
	self < 20 ifTrue: [
		^units at: self
	].
	self < 60 siVrai: [
	answer := #('vingt' 'trente' 'quarante' 'cinquante')
			at: self // 10 - 1.
	(self \\ 10) = 0 ifFalse: [
		(self  \\ 10) = 1 siVrai: [
			answer := answer,'-et-un'.
			] siFaux: [
		answer := answer,'-',(units at: self \\ 10)
		].
	].
	] siFaux: [
	answer := #('soixante' 'quatre-vingt') en: self // 20 - 2.
	(self \\ 20) = 0 siFaux: [
		(self  \\ 10) = 1 siVrai: [
			answer := answer,'-et-',(units en: self \\ 20).
			] siFaux: [
		answer := answer,'-',(units en: self \\ 20)].
	].
	].
	^answer! !

!Float methodsFor: '*MathsOntologie' stamp: 'AlainBusser 10/18/2012 16:56'!
commeFraction

	^self asFraction.! !

!Float methodsFor: '*MathsOntologie' stamp: 'AlainBusser 10/18/2012 16:57'!
commeFractionApproche

	^self asApproximateFraction.! !

!Float methodsFor: '*MathsOntologie' stamp: 'AlainBusser 10/18/2012 16:56'!
commeFractionApproche: ordre

	^self asApproximateFraction: ordre.! !

!Float methodsFor: '*MathsOntologie' stamp: 'AlainBusser 10/18/2012 16:57'!
commeFractionApprocheDordre: ordre

	^self asApproximateFractionAtOrder: ordre.! !

!Float methodsFor: '*MathsOntologie' stamp: 'AlainBusser 10/18/2012 16:55'!
commeFractionDcimale

	^self asMinimalDecimalFraction.! !

!Float methodsFor: '*MathsOntologie' stamp: 'AlainBusser 10/18/2012 16:54'!
commeVraieFraction

	^self asTrueFraction.! !

!BlockClosure methodsFor: '*MathsOntologie' stamp: 'AlainBusser 12/5/2012 14:12'!
dessineDe: xMin jusque: xMax

	| x y tabval diagramme trac sommets yMin yMax x0 x1 y0 y1 z |
	( xMin isNumber et: (xMax isNumber)) siVrai: [
	tabval := Array new: 200.
	(1 jusque: 200) fais: [ :n |
		x := (xMax-xMin)*n/200 + xMin.
		tabval en: n pose: (self valeur: x).
		].
	yMin := tabval min.
	yMax := tabval max.
	(1 jusque: 200) fais: [ :n |
		y := tabval en: n.
		y := (y-yMin)/(yMax-yMin).
		y := 1-y.
		y := y *160+10.
		tabval en: n pose: y.
		].
	sommets := Array new: 200.
	(1 jusque: 200) fais: [ :n |
		sommets en: n pose: ((n+10)@(tabval en: n)). 
		].
	diagramme := Morph new color: (Color cyan alpha: 0.2).
	diagramme extent: 220@180.
	diagramme borderWidth: 2.
	diagramme setBorderStyle: #complexRaised.
	trac := PolygonMorph new color: (Color yellow alpha: 0.2).
	trac makeOpenOrClosed.
	trac toggleSmoothing.
	trac lineBorderColor: (Color red alpha: 0.5).
	trac borderWidth: 2.
	trac setVertices: sommets.
	diagramme addMorph: trac.
	diagramme openInWorld.
	].


	( xMin isPoint et: (xMax isPoint)) siVrai: [
		x0 := xMin x min: (xMax x).
		x1 := xMin x max: (xMax x).
		y0 := xMin y min: (xMax y).
		y1 := xMin y max: (xMax y).
		sommets := Array new: 11.
		(1 jusque: 11) fais: [ :nx | sommets en: nx pose: (Array new: 11)].
		(1 jusque: 11) fais: [ :nx |
			 (1 jusque: 11) fais: [ :ny |
				x := x0 + ((nx prcdent) * (x1-x0) / 10).
				y := y0 + ((ny prcdent) * (y1-y0) / 10).
				z := self valeur: ((x@y) commeComplexe).
				z := (z x)@(z y).
				(sommets en: nx) en: ny pose: z.
				].
			].
		x0 := sommets injecte: 0 dans: [ :m :t | m min: t min].
		x1 := sommets injecte: 0 dans: [ :m :t | m max: t max].
		(1 jusque: 11) fais: [ :nx |
			(1 jusque: 11) fais: [ :ny |
				(sommets en: nx) en: ny pose: (((sommets en: nx) en: ny) -x0 / (x1 - x0) * 200).
				].
			].
	diagramme := Morph new color: (Color green alpha: 0.1).
	diagramme extent: 200@200.
	diagramme borderWidth: 2.
	diagramme setBorderStyle: #complexRaised.
	diagramme openInWorld.
	(1 jusque: 11) fais: [ :ny |
		trac := PolygonMorph new color: (Color yellow alpha: 0.2).
	trac makeOpenOrClosed.
	trac toggleSmoothing.
	trac lineBorderColor: (Color blue alpha: 0.5).
	trac borderWidth: 2.
	tabval := Array new: 11.
	(1 jusque: 11) fais: [ :nx |
		tabval en: nx pose: ((sommets en: nx) en: ny).
		].
	trac setVertices:  tabval.
	diagramme addMorph: trac.	
		].
	(1 jusque: 11) fais: [ :nx |
		trac := PolygonMorph new color: (Color yellow alpha: 0.2).
	trac makeOpenOrClosed.
	trac toggleSmoothing.
	trac lineBorderColor: (Color red alpha: 0.5).
	trac borderWidth: 2.
	trac setVertices:  (sommets en: nx).
	diagramme addMorph: trac.
		].	
		].! !

!BlockClosure methodsFor: '*MathsOntologie' stamp: 'AlainBusser 11/8/2012 19:31'!
dureCombien
	
	^self timeToRun.! !

!BlockClosure methodsFor: '*MathsOntologie' stamp: 'AlainBusser 11/25/2012 15:59'!
driveEn: unNombre

	| dx |
	dx := 0.000001.
	^(((self valeur: (unNombre+dx))-(self valeur: (unNombre-dx)))/(2*dx)).! !

!BlockClosure methodsFor: '*MathsOntologie' stamp: 'AlainBusser 11/25/2012 16:58'!
intgraleDe: xMin jusque: xMax

	| dx  somme |
	dx := (xMax-xMin)/10000.0.
	somme := ((self valeur: xMin)*dx/2) oppos.
	(xMin jusque: xMax parPasDe: dx) fais: [ :x |
		somme := somme + (dx*(self valeur: x)).
		].
	somme := somme - (((self valeur: xMax)*dx/2) oppos).
	^somme.! !

!BlockClosure methodsFor: '*MathsOntologie' stamp: 'AlainBusser 12/5/2012 11:04'!
maximumEntre: xMin et: xMax

	| a b dx M |
	a := (xMin min: xMax).
	b := (xMin max: xMax).
	dx := (b-a)/10.
	[ dx > 0.000001] tantQueVrai: [
		M := ((a jusque: b parPasDe: dx) picore: [ :x | self valeur: x]) max.
		a := (a jusque: b parPasDe: dx) choisis: [ :x | M=(self valeur: x)].
		a := a en: 1.
		b := xMax min: a+(dx/2).
		a := xMin max: (a-(dx/2)).
		dx := dx/10.
		].
	^M.! !

!BlockClosure methodsFor: '*MathsOntologie' stamp: 'AlainBusser 12/5/2012 11:06'!
minimumEntre: xMin et: xMax

	| a b dx M |
	a := (xMin min: xMax).
	b := (xMin max: xMax).
	dx := (b-a)/10.
	[ dx > 0.000001] tantQueVrai: [
		M := ((a jusque: b parPasDe: dx) picore: [ :x | self valeur: x]) min.
		a := (a jusque: b parPasDe: dx) choisis: [ :x | M=(self valeur: x)].
		a := a en: 1.
		b := xMax min: (a+(dx/2)).
		a := xMin max: (a-(dx/2)).
		dx := dx/10.
		].
	^M.! !

!BlockClosure methodsFor: '*MathsOntologie' stamp: 'AlainBusser 10/20/2012 16:33'!
tantQueFaux: unBloc

	^self whileFalse: unBloc.! !

!BlockClosure methodsFor: '*MathsOntologie' stamp: 'AlainBusser 10/20/2012 16:33'!
tantQueVrai: unBloc

	^self whileTrue: unBloc.! !

!BlockClosure methodsFor: '*MathsOntologie' stamp: 'AlainBusser 10/20/2012 16:25'!
valeur
	
	^self value.! !

!BlockClosure methodsFor: '*MathsOntologie' stamp: 'AlainBusser 10/20/2012 16:26'!
valeur: unArgument
	
	^self value: unArgument.! !

!BlockClosure methodsFor: '*MathsOntologie' stamp: 'AlainBusser 11/2/2012 18:00'!
valeur: unArgument valeur: unAutre
	
	^self value: unArgument value: unAutre.! !

!BlockClosure methodsFor: '*MathsOntologie' stamp: 'AlainBusser 11/8/2012 17:43'!
valeur: unArgument valeur: unAutre valeur: unTroisime
	
	^self value: unArgument value: unAutre value: unTroisime.! !

!BlockClosure methodsFor: '*MathsOntologie' stamp: 'AlainBusser 12/5/2012 11:35'!
valeurAnnulantEntre: xMin et: xMax

	| a b c |
	((self valeur: xMin) signe = ((self valeur: xMax) signe)) siFaux: [
	a := xMin commeDcimal.
	b := xMax commeDcimal.
	16 foisRpte: [
		c := (a+b)/2.
		((self valeur: c) signe = ((self valeur: a) signe)) siVrai: [
			a := c.
			] siFaux: [
			b := c.
			].
		].
	^c.
	].! !

!BlockClosure methodsFor: '*MathsOntologie' stamp: 'AlainBusser 12/5/2012 11:03'!
valeurMaximisantEntre: xMin et: xMax

	| a b dx M |
	a := (xMin min: xMax).
	b := (xMin max: xMax).
	dx := (b-a)/10.
	[ dx > 0.000001] tantQueVrai: [
		M := ((a jusque: b parPasDe: dx) picore: [ :x | self valeur: x]) max.
		a := (a jusque: b parPasDe: dx) choisis: [ :x | M=(self valeur: x)].
		a := a en: 1.
		b := xMax min: (a+(dx/2)).
		a := xMin max: (a-(dx/2)).
		dx := dx/10.
		].
	^((a+b)/2).! !

!BlockClosure methodsFor: '*MathsOntologie' stamp: 'AlainBusser 12/5/2012 11:07'!
valeurMinimisantEntre: xMin et: xMax

	| a b dx M |
	a := (xMin min: xMax).
	b := (xMin max: xMax).
	dx := (b-a)/10.
	[ dx > 0.000001] tantQueVrai: [
		M := ((a jusque: b parPasDe: dx) picore: [ :x | self valeur: x]) min. 
		a := (a jusque: b parPasDe: dx) choisis: [ :x | M=(self valeur: x)].
		a := a en: 1.
		b := xMax min: (a+(dx/2)).
		a := xMin max: (a-(dx/2)).
		dx := dx/10.
		].
	^((a+b)/2).! !

!True methodsFor: '*MathsOntologie' stamp: 'AlainBusser 10/18/2012 11:17'!
afficheSur: unFlux

	^self printOn: unFlux.! !

!Duration methodsFor: '*MathsOntologie' stamp: 'AlainBusser 10/29/2012 22:02'!
arrondiA: uneDure
	
	^self roundTo: uneDure.! !

!Duration methodsFor: '*MathsOntologie' stamp: 'AlainBusser 10/29/2012 22:05'!
enHeures

	^self asHours.! !

!Duration methodsFor: '*MathsOntologie' stamp: 'AlainBusser 10/29/2012 22:06'!
enJours
	
	^self asDays.! !

!Duration methodsFor: '*MathsOntologie' stamp: 'AlainBusser 10/29/2012 22:05'!
enMinutes

	^self asMinutes.! !

!Duration methodsFor: '*MathsOntologie' stamp: 'AlainBusser 10/29/2012 22:04'!
enNanosecondes

	^self asNanoSeconds.! !

!Duration methodsFor: '*MathsOntologie' stamp: 'AlainBusser 10/29/2012 22:04'!
enSecondes

	^self asSeconds.! !

!Duration methodsFor: '*MathsOntologie' stamp: 'AlainBusser 10/29/2012 22:05'!
enmillisecondes

	^self asMilliSeconds.! !

!Duration methodsFor: '*MathsOntologie' stamp: 'AlainBusser 10/29/2012 22:02'!
tronquA: uneDure
	
	^self truncateTo: uneDure.! !

!Number methodsFor: '*MathsOntologie' stamp: 'AlainBusser 12/5/2012 16:00'!
* unComplexe

	^(unComplexe * self).! !

!Number methodsFor: '*MathsOntologie-printing' stamp: 'AlainBusser 10/27/2012 14:45'!
affiche

	^self printString.! !

!Number methodsFor: '*MathsOntologie-printing' stamp: 'AlainBusser 10/27/2012 14:45'!
afficheEnBase: UneBase

	^self printStringBase: UneBase.! !

!Number methodsFor: '*MathsOntologie-truncation and roundoff' stamp: 'AlainBusser 10/27/2012 14:50'!
arrondiA: UnNombre
	"rpond l'arrondi  UnNombre prs.
	Par exemple 2 racine arrondiA: 0.01 rpond 1.41"

	^self roundTo: UnNombre.! !

!Number methodsFor: '*MathsOntologie-truncation and roundoff' stamp: 'AlainBusser 10/27/2012 14:50'!
arrondiDfautA: UnNombre

	"rpond l'arrondi par dfaut;
	par exemple, 2 racine arrondiExcsA: 0.01 rpond 1.41"
	
	^self roundDownTo: UnNombre.! !

!Number methodsFor: '*MathsOntologie-truncation and roundoff' stamp: 'AlainBusser 10/27/2012 14:50'!
arrondiEntier

	"rpond l'arrondi  l'entier le plus proche;
	par exemple, 2 racine arrondiEntier rpond 1"
	
	^self rounded.! !

!Number methodsFor: '*MathsOntologie-truncation and roundoff' stamp: 'AlainBusser 10/27/2012 14:50'!
arrondiExcsA: UnNombre

	"rpond l'arrondi  l'excs;
	par exemple, 2 racine arrondiExcsA: 0.01 rpond 1.42"
	
	^self roundUpTo: UnNombre.! !

!Number methodsFor: '*MathsOntologie' stamp: 'AlainBusser 10/18/2012 11:44'!
auCarr

	^self squared.! !

!Number methodsFor: '*MathsOntologie' stamp: 'AlainBusser 11/2/2012 17:10'!
auCube

	^self puissance: 3.! !

!Number methodsFor: '*MathsOntologie' stamp: 'AlainBusser 10/25/2012 18:40'!
augmentDePourcents: unPourcentage
	"augmente d'un pourcentage.
	Par exemple 200 augmentDePourcents: 6 rpond 212"

	^self * (1 + (unPourcentage / 100)).! !

!Number methodsFor: '*MathsOntologie' stamp: 'AlainBusser 10/18/2012 12:13'!
avecLeSigneDe: UnNombre

	^UnNombre copySignTo: self.! !

!Number methodsFor: '*MathsOntologie' stamp: 'AlainBusser 12/1/2012 14:53'!
commeComplexe
	
	^(self@0) commeComplexe.! !

!Number methodsFor: '*MathsOntologie-converting' stamp: 'AlainBusser 10/27/2012 14:54'!
commeDure

	^self asDuration.! !

!Number methodsFor: '*MathsOntologie-converting' stamp: 'AlainBusser 10/27/2012 14:54'!
commeDcimal

	^self asFloat.! !

!Number methodsFor: '*MathsOntologie-converting' stamp: 'AlainBusser 10/27/2012 14:54'!
commeDcimalGradu

	^self asScaledDecimal.! !

!Number methodsFor: '*MathsOntologie-converting' stamp: 'AlainBusser 10/27/2012 14:55'!
commeDcimalGradu: echelle

	^self asScaledDecimal: echelle.! !

!Number methodsFor: '*MathsOntologie-converting' stamp: 'AlainBusser 10/27/2012 14:55'!
commeEntier

	^self asInteger.! !

!Number methodsFor: '*MathsOntologie-converting' stamp: 'AlainBusser 10/27/2012 14:55'!
commeNombre

	^self asNumber.! !

!Number methodsFor: '*MathsOntologie' stamp: 'AlainBusser 10/20/2012 11:25'!
cosinus
	"cosinus en degrs"
	
	^self degreeCos.! !

!Number methodsFor: '*MathsOntologie' stamp: 'AlainBusser 10/18/2012 11:50'!
degrs

	^self radiansToDegrees.! !

!Number methodsFor: '*MathsOntologie' stamp: 'AlainBusser 11/6/2012 18:15'!
devientCombienSachantQue: unNombre devient: unAutreNombre
	"rgle de trois"

	^(self * unAutreNombre / unNombre).! !

!Number methodsFor: '*MathsOntologie-printing' stamp: 'AlainBusser 10/28/2012 17:32'!
enPourcents

	^(self *100) asString,' %'.! !

!Number methodsFor: '*MathsOntologie-testing' stamp: 'AlainBusser 10/27/2012 14:55'!
estDivisiblePar: UnNombre

	^self isDivisibleBy: UnNombre.! !

!Number methodsFor: '*MathsOntologie-testing' stamp: 'AlainBusser 11/21/2012 11:33'!
estDcimal

	^(self isFloat).! !

!Number methodsFor: '*MathsOntologie-testing' stamp: 'AlainBusser 11/21/2012 11:32'!
estEntier

	^(self isInteger).! !

!Number methodsFor: '*MathsOntologie-testing' stamp: 'AlainBusser 10/27/2012 14:55'!
estInfini

	^self isInfinite.! !

!Number methodsFor: '*MathsOntologie-testing' stamp: 'AlainBusser 10/27/2012 14:55'!
estNul

	^self isZero.! !

!Number methodsFor: '*MathsOntologie-testing' stamp: 'AlainBusser 10/27/2012 14:54'!
estUnNombre

	^self isNumber.! !

!Number methodsFor: '*MathsOntologie-converting' stamp: 'AlainBusser 10/27/2012 14:56'!
heures

	^self hours.! !

!Number methodsFor: '*MathsOntologie' stamp: 'AlainBusser 10/18/2012 12:00'!
impair
	
	^self odd.! !

!Number methodsFor: '*MathsOntologie' stamp: 'AlainBusser 10/18/2012 18:15'!
inverse

	^self reciprocal.! !

!Number methodsFor: '*MathsOntologie-converting' stamp: 'AlainBusser 10/27/2012 14:56'!
jours

	^self days.! !

!Number methodsFor: '*MathsOntologie' stamp: 'AlainBusser 10/18/2012 11:34'!
jusque: UnNombre

	^self to: UnNombre.! !

!Number methodsFor: '*MathsOntologie' stamp: 'AlainBusser 11/8/2012 18:09'!
jusque: UnNombre faire: UnBloc
	"boucle  condition de sortie"

	^self to: UnNombre do: UnBloc.! !

!Number methodsFor: '*MathsOntologie' stamp: 'AlainBusser 10/28/2012 17:33'!
jusque: UnNombre parPasDe: UnPas

	"rpond un intervalle"

	^self to: UnNombre by: UnPas.! !

!Number methodsFor: '*MathsOntologie' stamp: 'AlainBusser 10/28/2012 17:33'!
jusque: UnNombre parPasDe: UnPas faire: UnBloc

	^self to: UnNombre by: UnPas do: UnBloc.! !

!Number methodsFor: '*MathsOntologie-converting' stamp: 'AlainBusser 10/27/2012 14:56'!
millisecondes

	^self milliSeconds.! !

!Number methodsFor: '*MathsOntologie' stamp: 'AlainBusser 12/9/2012 08:12'!
moyenneAvec: unNombre
	
	^((self + unNombre)/2).! !

!Number methodsFor: '*MathsOntologie-testing' stamp: 'AlainBusser 10/27/2012 14:54'!
nEstPasUnNombre

	^self isNaN.! !

!Number methodsFor: '*MathsOntologie-converting' stamp: 'AlainBusser 10/27/2012 14:53'!
nanosecondes

	^self nanoSeconds.! !

!Number methodsFor: '*MathsOntologie' stamp: 'AlainBusser 10/18/2012 11:59'!
ngatif
	
	^self negative.! !

!Number methodsFor: '*MathsOntologie' stamp: 'AlainBusser 10/18/2012 12:01'!
oppos

	^self negated.! !

!Number methodsFor: '*MathsOntologie' stamp: 'AlainBusser 10/18/2012 12:00'!
pair
	
	^self even.! !

!Number methodsFor: '*MathsOntologie-truncation and roundoff' stamp: 'AlainBusser 10/27/2012 14:49'!
partieEntire

	^self integerPart.! !

!Number methodsFor: '*MathsOntologie-truncation and roundoff' stamp: 'AlainBusser 10/27/2012 14:48'!
partieFractionnaire

	^self fractionPart.! !

!Number methodsFor: '*MathsOntologie' stamp: 'AlainBusser 10/18/2012 11:59'!
positif
	
	^self positive.! !

!Number methodsFor: '*MathsOntologie' stamp: 'AlainBusser 10/25/2012 18:38'!
pourcentsDe: UnNombre
	"rpond un pourcentage.
	Par exemple 6 pourcentsDe: 200 rpond 12"

	^self * UnNombre / 100.! !

!Number methodsFor: '*MathsOntologie' stamp: 'AlainBusser 10/18/2012 12:13'!
procheDe: UnNombre

	^self closeTo: UnNombre.! !

!Number methodsFor: '*MathsOntologie' stamp: 'AlainBusser 10/18/2012 11:50'!
puissance: UnNombre

	^self raisedTo: UnNombre.! !

!Number methodsFor: '*MathsOntologie' stamp: 'AlainBusser 10/18/2012 11:44'!
racine

	^self sqrt.! !

!Number methodsFor: '*MathsOntologie' stamp: 'AlainBusser 11/6/2012 18:15'!
racineCubique

	^(self racineNime: 3).! !

!Number methodsFor: '*MathsOntologie' stamp: 'AlainBusser 10/18/2012 16:46'!
racineNime: unEntier

	^self nthRoot: unEntier.! !

!Number methodsFor: '*MathsOntologie-converting' stamp: 'AlainBusser 10/27/2012 14:52'!
radians
	
	^self degreesToRadians.! !

!Number methodsFor: '*MathsOntologie' stamp: 'AlainBusser 10/18/2012 11:47'!
reste: UnNombre

	^self rem: UnNombre.! !

!Number methodsFor: '*MathsOntologie-converting' stamp: 'AlainBusser 10/27/2012 14:53'!
secondes

	^self seconds.! !

!Number methodsFor: '*MathsOntologie-converting' stamp: 'AlainBusser 10/27/2012 14:52'!
semaines

	^self weeks.! !

!Number methodsFor: '*MathsOntologie' stamp: 'AlainBusser 10/18/2012 11:45'!
signe
	
	^self sign.! !

!Number methodsFor: '*MathsOntologie' stamp: 'AlainBusser 10/20/2012 11:25'!
sinus
	"sinus en degrs"
	
	^self degreeSin.! !

!Number methodsFor: '*MathsOntologie' stamp: 'AlainBusser 10/18/2012 11:42'!
strictementPositif

	^self strictlyPositive.! !

!Number methodsFor: '*MathsOntologie' stamp: 'AlainBusser 10/20/2012 11:27'!
tangente
	"tangente en degrs"
	
	^(self sinus / (self cosinus)).! !

!Number methodsFor: '*MathsOntologie-truncation and roundoff' stamp: 'AlainBusser 10/27/2012 14:48'!
troncatureEntire


	^self floor.! !

!Number methodsFor: '*MathsOntologie-truncation and roundoff' stamp: 'AlainBusser 10/27/2012 14:47'!
tronqu
	^self truncated.! !

!Number methodsFor: '*MathsOntologie-truncation and roundoff' stamp: 'AlainBusser 12/5/2012 15:42'!
tronquA: UnNombre

	"affiche le nombre tronqu  UnOmbre prs.
	Par exemple, 2 racine tronquA: 0.01 renvoie 1.41"
	
	^(self truncateTo: UnNombre).! !

!Dictionary methodsFor: '*MathsOntologie' stamp: 'AlainBusser 12/9/2012 08:14'!
en: key
	
	^(self at: key).! !

!Dictionary methodsFor: '*MathsOntologie' stamp: 'AlainBusser 11/21/2012 14:58'!
en: clef place: valeur
	
	^(self at: clef put: valeur).! !

!SortedCollection methodsFor: '*MathsOntologie' stamp: 'AlainBusser 11/8/2012 17:24'!
Q1
	"rpond le premier quartile."

	^(self at: self size + 1 // 4).! !

!SortedCollection methodsFor: '*MathsOntologie' stamp: 'AlainBusser 11/8/2012 17:24'!
Q3
	"rpond le troisime quartile."

	^(self reverse at: self size + 1 // 4).! !

Point subclass: #Complexe
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MathsOntologie'!

!Complexe class methodsFor: 'as yet unclassified' stamp: 'AlainBusser 12/1/2012 14:37'!
initialize
	
	super initialize.! !

!Complexe methodsFor: '*MathsOntologie-geometry' stamp: 'AlainBusser 12/1/2012 14:44'!
* facteur
	
	(facteur estComplexe) siVrai: [
		^((x * facteur x - (y * facteur y))@(x * facteur y + (y * facteur x))) commeComplexe.
		] siFaux: [
		^(Complexe new setX: (x * facteur) setY: (y * facteur)).
		].! !

!Complexe methodsFor: '*MathsOntologie-geometry' stamp: 'AlainBusser 12/3/2012 21:35'!
+ facteur
	
	(facteur estComplexe) siVrai: [
		^((x + facteur x)@(y + facteur y)) commeComplexe.
		] siFaux: [
		^(Complexe new setX: (x + facteur) setY: y ).
		].! !

!Complexe methodsFor: '*MathsOntologie-geometry' stamp: 'AlainBusser 12/3/2012 21:35'!
- facteur
	
	(facteur estComplexe) siVrai: [
		^((x - facteur x)@(y - facteur y)) commeComplexe.
		] siFaux: [
		^(Complexe new setX: (x - facteur) setY: y).
		].! !

!Complexe methodsFor: '*MathsOntologie-geometry' stamp: 'AlainBusser 12/1/2012 16:04'!
/ unComplexe

	^(self * (unComplexe inverse)).! !

!Complexe methodsFor: '*MathsOntologie-geometry' stamp: 'AlainBusser 12/5/2012 14:41'!
arcCos
	
	^(((Float pi / 2) commeComplexe)-(self arcSin)).! !

!Complexe methodsFor: '*MathsOntologie-geometry' stamp: 'AlainBusser 12/5/2012 14:38'!
arcSin
	
	| i u |
	u := 1 commeComplexe.
	i := (0@1) commeComplexe.
	^  (i oppos)*(((u - (self auCarr)) racine + ( i* self)) ln) .! !

!Complexe methodsFor: '*MathsOntologie-geometry' stamp: 'AlainBusser 12/5/2012 14:35'!
arcTan
	
	| i u |
	u := 1 commeComplexe.
	i := (0@1) commeComplexe.
	^(i oppos / 2 * (((u - (self * i))/(u + (self * i))) ln)).! !

!Complexe methodsFor: '*MathsOntologie-geometry' stamp: 'AlainBusser 12/1/2012 14:51'!
argument
	
	^self theta.! !

!Complexe methodsFor: '*MathsOntologie-geometry' stamp: 'AlainBusser 12/1/2012 16:06'!
auCarr
	
	^(self * self).! !

!Complexe methodsFor: '*MathsOntologie-geometry' stamp: 'AlainBusser 12/1/2012 16:07'!
auCube
	
	^(self * self * self).! !

!Complexe methodsFor: '*MathsOntologie-geometry' stamp: 'AlainBusser 12/1/2012 16:03'!
conjugu
	
	^(((self x)@(self y oppos)) commeComplexe). ! !

!Complexe methodsFor: '*MathsOntologie-geometry' stamp: 'AlainBusser 12/1/2012 16:59'!
cos

	| r s i |
	i := (0@1) commeComplexe.
	r := (i * self) exp.
	s := (i * self) oppos exp.
	^((r+s)/2) commeComplexe.
	! !

!Complexe methodsFor: '*MathsOntologie-geometry' stamp: 'AlainBusser 12/1/2012 14:45'!
estComplexe
	
	^true.! !

!Complexe methodsFor: '*MathsOntologie-geometry' stamp: 'AlainBusser 12/1/2012 16:27'!
exp
	
	| x1 y1 r1 |
	r1 := self x exp.
	x1 := self y cos * r1.
	y1 := self y sin * r1.
	^((x1@y1) commeComplexe).! !

!Complexe methodsFor: '*MathsOntologie-geometry' stamp: 'AlainBusser 12/1/2012 16:01'!
inverse
	
	^(self conjugu / (self moduleAuCarr)).! !

!Complexe methodsFor: '*MathsOntologie-geometry' stamp: 'AlainBusser 12/1/2012 16:33'!
ln
	
	| x1 y1 |
	x1 := self r ln.
	y1 := self theta.
	^((x1@y1) commeComplexe).! !

!Complexe methodsFor: '*MathsOntologie-geometry' stamp: 'AlainBusser 12/1/2012 15:44'!
module

	^self r.! !

!Complexe methodsFor: '*MathsOntologie-geometry' stamp: 'AlainBusser 12/1/2012 16:00'!
moduleAuCarr
	
	^(self x auCarr + (self y auCarr)).! !

!Complexe methodsFor: '*MathsOntologie-geometry' stamp: 'AlainBusser 12/1/2012 15:59'!
oppos
	
	^self negated commeComplexe.! !

!Complexe methodsFor: '*MathsOntologie-geometry' stamp: 'AlainBusser 12/1/2012 14:52'!
partieImaginaire
	
	^self y.! !

!Complexe methodsFor: '*MathsOntologie-geometry' stamp: 'AlainBusser 12/1/2012 14:51'!
partieRelle
	
	^self x.! !

!Complexe methodsFor: '*MathsOntologie-geometry' stamp: 'AlainBusser 12/1/2012 16:14'!
printOn: aStream

	x printOn: aStream.
	(y positif) siFaux: [
		aStream nextPut: $-.
		(y oppos) printOn: aStream.
		] siVrai: [
		aStream nextPut: $+.
		y printOn: aStream.
	].	
	aStream nextPut: $i.! !

!Complexe methodsFor: '*MathsOntologie-geometry' stamp: 'AlainBusser 12/1/2012 16:17'!
puissance: unEntier
	
	| p |
	p := 1 commeComplexe.
	(unEntier positif) siVrai: [
	unEntier foisRpte: [
		p := p * self.
		].
	] siFaux: [
	(unEntier oppos) foisRpte: [
		p := p / self.
		].
	].
	^p.! !

!Complexe methodsFor: '*MathsOntologie-geometry' stamp: 'AlainBusser 12/1/2012 16:43'!
racine
	
	| x1 y1 r1 r2 |
	x1 := ((self r + (self x)) / 2) racine.
	r2 := ((self r - (self x)) / 2) racine.
	(y positif) siVrai: [ y1 := r2] siFaux: [ y1 := r2 oppos].
	^((x1@y1) commeComplexe).! !

!Complexe methodsFor: '*MathsOntologie-geometry' stamp: 'AlainBusser 12/1/2012 16:53'!
racineCubique
	
	| r1 t1 x1 y1 |
	r1 := self r racineCubique.
	t1 := self theta / 3.
	x1 := r1 * (t1 cos).
	y1 := r1 * (t1 sin).
	^((x1@y1) commeComplexe).! !

!Complexe methodsFor: '*MathsOntologie-geometry' stamp: 'AlainBusser 12/1/2012 16:54'!
racineNime: unEntier
	
	| r1 t1 x1 y1 |
	r1 := self r racineNime: unEntier.
	t1 := self theta / unEntier.
	x1 := r1 * (t1 cos).
	y1 := r1 * (t1 sin).
	^((x1@y1) commeComplexe).! !

!Complexe methodsFor: '*MathsOntologie-geometry' stamp: 'AlainBusser 12/1/2012 17:01'!
sin

	| r s i |
	i := (0@1) commeComplexe.
	r := (i * self) exp * i oppos.
	s := (i * self) oppos exp * i oppos.
	^((r-s)/2) commeComplexe.
	! !

!Complexe methodsFor: '*MathsOntologie-geometry' stamp: 'AlainBusser 12/5/2012 14:08'!
tan
	
	^(self sin / (self cos)).! !

!Point methodsFor: '*MathsOntologie-geometry' stamp: 'AlainBusser 11/25/2012 11:33'!
aireDuTriangleAvec: unPoint et: autrePoint
	
	^(((self triangleArea: unPoint with: autrePoint) / 2 ) abs).! !

!Point methodsFor: '*MathsOntologie-geometry' stamp: 'AlainBusser 12/1/2012 14:39'!
commeComplexe
	
	| z |
	z := Complexe new.
	z setX: (self x) setY: (self y).
	^z.! !

!Point methodsFor: '*MathsOntologie-geometry' stamp: 'AlainBusser 11/25/2012 11:18'!
distanceAuCarrJusque: unPoint 
	
	^ (self squaredDistanceTo: unPoint).! !

!Point methodsFor: '*MathsOntologie-geometry' stamp: 'AlainBusser 12/1/2012 12:51'!
dterminant: unVecteur
	
	^(self crossProduct: unVecteur).! !

!Point methodsFor: '*MathsOntologie-geometry' stamp: 'AlainBusser 11/25/2012 11:52'!
estAlignAvec: unPoint et: autrePoint

	^((unPoint-self) estColinaireAvec: (autrePoint-self)).! !

!Point methodsFor: '*MathsOntologie-geometry' stamp: 'AlainBusser 12/1/2012 12:51'!
estColinaireAvec: unVecteur
	
	^((self dterminant: unVecteur)=0).! !

!Point methodsFor: '*MathsOntologie-geometry' stamp: 'AlainBusser 11/25/2012 11:35'!
estDansLeCerclePassantPar: point1 et: point2 et: point3
	
	^(self isInsideCircle: point1 with: point2 with: point3).! !

!Point methodsFor: '*MathsOntologie-geometry' stamp: 'AlainBusser 11/25/2012 11:27'!
estDansLeTriangleDeSommets: point1 et: point2 et: point3
	
	^(self insideTriangle:  point1 with: point2 with: point3).! !

!Point methodsFor: '*MathsOntologie-geometry' stamp: 'AlainBusser 11/25/2012 11:37'!
milieu: unPoint
	
	^((self + unPoint)/2).! !

!Point methodsFor: '*MathsOntologie-geometry' stamp: 'AlainBusser 12/9/2012 08:11'!
pointLePlusProcheSurLaDroitePassantPar: unPoint et: autrePoint
	
	^(self nearestPointAlongLineFrom: unPoint to: autrePoint).! !

!Point methodsFor: '*MathsOntologie-geometry' stamp: 'AlainBusser 11/25/2012 11:42'!
scalaire: unVecteur
	
	^(self dotProduct: unVecteur).! !

!Point methodsFor: '*MathsOntologie-geometry' stamp: 'AlainBusser 11/25/2012 11:47'!
symtriqueParRapport: unPoint

	^(2 * unPoint - self).! !

!Point methodsFor: '*MathsOntologie-geometry' stamp: 'AlainBusser 12/9/2012 08:11'!
symtriqueParRapportLaDroitePassantPar: unPoint et: autrePoint
	
	^(self symtriqueParRapport: (self pointLePlusProcheSurLaDroitePassantPar: unPoint et: autrePoint)).! !

!Point methodsFor: '*MathsOntologie-geometry' stamp: 'AlainBusser 11/25/2012 11:20'!
tourneDe: unAngle autourDe: centre

	^(self rotateBy: unAngle about: centre).! !

!Point methodsFor: '*MathsOntologie-geometry' stamp: 'AlainBusser 11/25/2012 11:19'!
translateSelon: unVecteur
	
	^(self translateBy: unVecteur).! !

!Point methodsFor: '*MathsOntologie-geometry' stamp: 'AlainBusser 11/25/2012 11:38'!
vecteur: unPoint
	
	^(unPoint - self).! !

!Point methodsFor: '*MathsOntologie-geometry' stamp: 'AlainBusser 12/1/2012 17:05'!
quationDroiteJusque: unPoint
	
	| eq m p v |
	v := self vecteur: unPoint.
	(v=0) siVrai: [eq :='Pas de droite passant par deux fois le mme point'.].
	((v x)=0) siVrai: [eq := 'x = ',((self x) commeTexte),'.']
	siFaux: [
		m := v y / (v x).
		p := self y - (m*self x).
		eq := 'y = ',(m commeTexte),'x'.
		(p positif) siVrai: [
			eq := eq,' + ',(p commeTexte).
			] siFaux: [
			eq := eq,' - ',(p oppos commeTexte).
			].
		].
	^eq.! !

!False methodsFor: '*MathsOntologie' stamp: 'AlainBusser 10/15/2012 21:54'!
afficheSur: unFlux

	^self printOn: unFlux.! !

!DateAndTime methodsFor: '*MathsOntologie' stamp: 'AlainBusser 11/8/2012 20:21'!
anne

	^self year.! !

!DateAndTime methodsFor: '*MathsOntologie' stamp: 'AlainBusser 11/8/2012 20:21'!
aujourdHui

	| texte |
	texte := (self nomDuJour),' le '.
	texte := texte,((self quantime) commeTexte),' '.
	texte := texte,(self nomDuMois),' ',((self anne) commeTexte).
	^texte.! !

!DateAndTime methodsFor: '*MathsOntologie' stamp: 'AlainBusser 11/8/2012 20:02'!
estBissextile
	
	^self isLeapYear.! !

!DateAndTime methodsFor: '*MathsOntologie' stamp: 'AlainBusser 11/8/2012 20:05'!
jourDansLanne
	
	^self dayOfYear.! !

!DateAndTime methodsFor: '*MathsOntologie' stamp: 'AlainBusser 11/8/2012 20:10'!
nomDuJour

	| noms |
	noms := Dictionary newFrom: {1->'Dimanche' . 2->'Lundi' . 3->'Mardi' . 4->'Mercredi' . 5->'Jeudi' . 6 ->'Vendredi' . 7->'Samedi'}.	
	^(noms at: (self dayOfWeek)).! !

!DateAndTime methodsFor: '*MathsOntologie' stamp: 'AlainBusser 11/8/2012 19:57'!
nomDuMois

	| noms |
	
	noms := Dictionary newFrom: {1->'Janvier' . 2->'Fvrier' . 3->'Mars' . 4->'Avril' . 5->'Mai' . 6->'Juin'.
	7->'Juillet' . 8->'Aot' . 9->'Septembre' . 10->'Octobre' . 11->'Novembre' . 12->'Dcembre'}.

	^ noms at: self month.
! !

!DateAndTime methodsFor: '*MathsOntologie' stamp: 'AlainBusser 11/8/2012 20:14'!
quantime
	
	^self dayOfMonth.! !

!Array methodsFor: '*MathsOntologie-modification' stamp: 'AlainBusser 10/20/2012 17:45'!
en: unIndice
	
	^self at: unIndice.! !

!Array methodsFor: '*MathsOntologie-modification' stamp: 'AlainBusser 10/26/2012 18:17'!
en: unIndice pose: unObjet
	
	^self at: unIndice put: unObjet.! !

MatrixTransform2x3 variableWordSubclass: #Matrice
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MathsOntologie'!

!Matrice methodsFor: 'composing' stamp: 'AlainBusser 12/5/2012 16:16'!
* uneMatrice
	
	
	(uneMatrice isNumber) siVrai: [
		^self composedWithLocal: (Matrice new setScale: uneMatrice).		
		].
	(uneMatrice isMatrixTransform2x3) siVrai: [
		^self composedWithLocal: uneMatrice.
		].
	! !

!Matrice methodsFor: 'composing' stamp: 'AlainBusser 12/5/2012 15:20'!
+ uneMatrice

	| M |
	M := Matrice new.
	M a11: (self a11 + (uneMatrice a11)).
	M a12: (self a12 + (uneMatrice a12)).
	M a13: (self a13 + (uneMatrice a13)).
	M a21: (self a21 + (uneMatrice a21)).
	M a22: (self a22 + (uneMatrice a22)).
	M a23: (self a23 + (uneMatrice a23)).
	
	^M.! !

!Matrice methodsFor: 'composing' stamp: 'AlainBusser 12/5/2012 15:20'!
- uneMatrice

	| M |
	M := Matrice new.
	M a11: (self a11 - (uneMatrice a11)).
	M a12: (self a12 - (uneMatrice a12)).
	M a13: (self a13 - (uneMatrice a13)).
	M a21: (self a21 - (uneMatrice a21)).
	M a22: (self a22 - (uneMatrice a22)).
	M a23: (self a23 - (uneMatrice a23)).
	
	^M.! !

!Matrice methodsFor: 'composing' stamp: 'AlainBusser 12/5/2012 15:21'!
/ uneMatrice

	^self * (uneMatrice inverse).! !

!Matrice methodsFor: 'truncating' stamp: 'AlainBusser 12/5/2012 15:44'!
arrondieA: dcimal
	
	| M |
	M := Matrice new.
	M a11: (self a11 arrondiA: dcimal).
	M a12: (self a12 arrondiA: dcimal).
	M a13: (self a13 arrondiA: dcimal).
	M a21: (self a21 arrondiA: dcimal).
	M a22: (self a22 arrondiA: dcimal).
	M a23: (self a23 arrondiA: dcimal).
	
	^M.! !

!Matrice methodsFor: 'truncating' stamp: 'AlainBusser 12/5/2012 15:55'!
arrondieEntier
	
	| M |
	M := Matrice new.
	M a11: (self a11 commeEntier).
	M a12: (self a12 commeEntier).
	M a13: (self a13 commeEntier).
	M a21: (self a21 commeEntier).
	M a22: (self a22 commeEntier).
	M a23: (self a23 commeEntier).
	
	^M.! !

!Matrice methodsFor: 'composing' stamp: 'AlainBusser 12/5/2012 15:22'!
auCarr

	^(self * self).! !

!Matrice methodsFor: 'composing' stamp: 'AlainBusser 12/5/2012 15:22'!
auCube

	^(self * self * self).! !

!Matrice methodsFor: 'truncating' stamp: 'AlainBusser 12/5/2012 16:21'!
commeFraction
	
	| M |
	M := Matrice new.
	M a11: (self a11 commeFraction).
	M a12: (self a12 commeFraction).
	M a13: (self a13 commeFraction).
	M a21: (self a21 commeFraction).
	M a22: (self a22 commeFraction).
	M a23: (self a23 commeFraction).
	
	^M.! !

!Matrice methodsFor: 'linear-algebra' stamp: 'AlainBusser 12/5/2012 16:25'!
dterminant
	
	^(self a11 * (self a22) - (self a12 * (self a21))).! !

!Matrice methodsFor: 'transforming points' stamp: 'AlainBusser 12/5/2012 15:07'!
estIdentit

	^self isIdentity.! !

!Matrice methodsFor: 'as yet unclassified' stamp: 'AlainBusser 12/5/2012 14:59'!
initialize
	
	super initialize.! !

!Matrice methodsFor: 'composing' stamp: 'AlainBusser 12/5/2012 15:15'!
inverse
	
	^self inverseTransformation.! !

!Matrice methodsFor: 'transforming points' stamp: 'AlainBusser 12/5/2012 15:06'!
inverseTransformeUnPoint: unPoint
	
	^(self invertPoint: unPoint).! !

!Matrice methodsFor: 'private' stamp: 'AlainBusser 12/5/2012 15:08'!
metAngle: unAngle
	
	^self setAngle: unAngle.! !

!Matrice methodsFor: 'private' stamp: 'AlainBusser 12/5/2012 15:08'!
metDcalage: unPoint
	
	^self setOffset: unPoint.! !

!Matrice methodsFor: 'private' stamp: 'AlainBusser 12/5/2012 15:09'!
metEchelle: k
	
	^self setScale: k.! !

!Matrice methodsFor: 'truncating' stamp: 'AlainBusser 12/5/2012 17:39'!
modulo: unEntier
	
	| M |
	M := Matrice new.
	M a11: (self a11 \\ unEntier).
	M a12: (self a12 \\ unEntier).
	M a13: (self a13 \\ unEntier).
	M a21: (self a21 \\ unEntier).
	M a22: (self a22 \\ unEntier).
	M a23: (self a23 \\ unEntier).
	
	^M.! !

!Matrice methodsFor: 'linear-algebra' stamp: 'AlainBusser 12/5/2012 16:36'!
polynomeCaractristique
	
	^[ :x | x auCarr - (x * (self trace)) + self dterminant ].! !

!Matrice methodsFor: 'printing' stamp: 'AlainBusser 12/5/2012 15:02'!
printOn: aStream
	aStream 
		nextPutAll: self class name;
		nextPut: $(;
		cr; print: self a11; tab; print: self a12;
		cr; print: self a21; tab; print: self a22;
		cr; nextPut:$).! !

!Matrice methodsFor: 'composing' stamp: 'AlainBusser 12/5/2012 15:30'!
puissance: unEntier

	| M |
	M := Matrice new.
	M rendIdentit.
	(unEntier positif) siVrai: [
		unEntier foisRpte: [
			M := M * self.
		].
	] siFaux: [
	(unEntier oppos) foisRpte: [
		M := M/self.
		].
	].
	^M.! !

!Matrice methodsFor: 'private' stamp: 'AlainBusser 12/5/2012 15:11'!
rendIdentit
	
	^self setIdentiy.! !

!Matrice methodsFor: 'linear-algebra' stamp: 'AlainBusser 12/5/2012 16:27'!
trace
	
	^(self a11 + (self a22)).! !

!Matrice methodsFor: 'transforming points' stamp: 'AlainBusser 12/5/2012 15:04'!
transformeUnPoint: unPoint
	
	^(self transformPoint: unPoint).! !

!Matrice methodsFor: 'transforming points' stamp: 'AlainBusser 12/5/2012 15:05'!
transformeUnVecteur: unVecteur
	
	^(self transformDirection: unVecteur).! !

!Matrice methodsFor: 'truncating' stamp: 'AlainBusser 12/5/2012 15:43'!
tronque
	
	| M |
	M := Matrice new.
	M a11: (self a11 tronqu).
	M a12: (self a12 tronqu).
	M a13: (self a13 tronqu).
	M a21: (self a21 tronqu).
	M a22: (self a22 tronqu).
	M a23: (self a23 tronqu).
	
	^M.! !

!Matrice methodsFor: 'truncating' stamp: 'AlainBusser 12/5/2012 15:54'!
tronqueA: dcimal
	
	| M |
	M := Matrice new.
	M a11: (self a11 tronquA: dcimal).
	M a12: (self a12 tronquA: dcimal).
	M a13: (self a13 tronquA: dcimal).
	M a21: (self a21 tronquA: dcimal).
	M a22: (self a22 tronquA: dcimal).
	M a23: (self a23 tronquA: dcimal).
	
	^M.! !

!Matrice methodsFor: 'linear-algebra' stamp: 'AlainBusser 12/5/2012 16:33'!
valeursPropresRelles
	
	| b c Delta S |
	b := self trace oppos.
	c := self dterminant.
	Delta := b auCarr - (4 * c).
	S := #() commeEnsemble.
	(Delta positif) siVrai: [
		S ajoute: ((b oppos - (Delta racine))/2).
		S ajoute: ((b oppos + (Delta racine))/2).
		].
	^S.! !

!Integer methodsFor: '*MathsOntologie' stamp: 'AlainBusser 11/2/2012 17:08'!
BezoutAvec: unEntier
	"rpond une solution (u,v) de Bezout"

	| g u v eq a b s |
	g := self pgcd: unEntier.
	eq := (self asString),' u + ',(unEntier asString),'  v = ',(g asString).
	a := self // g.
	b := unEntier // g.
	u := (a modulo: b) inverseModulo: b.
	v := (1 - a * u) // b.
	s := '(',(u asString),';',(v asString),') est solution de ',eq.
	^s.! !

!Integer methodsFor: '*MathsOntologie' stamp: 'AlainBusser 10/18/2012 17:15'!
auHasard

	^self atRandom.! !

!Integer methodsFor: '*MathsOntologie-printing' stamp: 'AlainBusser 11/8/2012 22:11'!
avecDesMots
	"SmallInteger maxVal asWords"
	| mils minus three num answer milCount pluriel |
	self = 0 ifTrue: [^'zero'].
	mils := #('' ' mille' ' million' ' milliard' ' billion' ' billiard' ' trillion' ' trilliard' ' quadrillion' ' quadrilliard' ' quintillion' ' quintilliard' ' sextillion' ' sextilliard' ' septillion' ' septilliard' ' octillion' ' octilliard' ' nonillion' ' nonilliard' ' dcillion' ' dcilliard').
	num := self.
	minus := ''.
	self < 0 ifTrue: [
		minus := 'moins '.
		num := num negated.
	].
	answer := String new.
	milCount := 1.
	[num > 0] whileTrue: [
		three := (num \\ 1000) troisChiffresEnNom. 
		pluriel := ((num \\ 1000)>1).
		num := num // 1000.
		three isEmpty ifFalse: [
			answer isEmpty ifFalse: [
				answer := ' ',answer
			].
		(pluriel and: [milCount>2]) ifTrue: [
			answer := three,(mils at: milCount),'s',answer.
			] ifFalse: [
			((pluriel not) and: [milCount=2]) ifTrue: [
				answer := (mils at: milCount),answer.
				] ifFalse: [
				answer := three,(mils at: milCount),answer.
				]
			].
		].
		milCount := milCount + 1.
	].
	^minus,answer! !

!Integer methodsFor: '*MathsOntologie-printing' stamp: 'AlainBusser 10/27/2012 14:32'!
avecDesMotsDn
	"SmallInteger maxVal asWords"
	| mils minus three num answer milCount |
	self = 0 ifTrue: [^'zero'].
	mils := #('' ' mille' ' millions' ' milliards' ' billions' ' billiards' ' trillions' ' trilliards' ' quadrillions' ' quadrilliards' ' quintillions' ' quintilliards' ' sextillions' ' sextilliards' ' septillions' ' septilliards' ' octillions' ' octilliards' ' nonillions' ' nonilliards' ' dcillions' ' dcilliards').
	num := self.
	minus := ''.
	self < 0 ifTrue: [
		minus := 'moins '.
		num := num negated.
	].
	answer := String new.
	milCount := 1.
	[num > 0] whileTrue: [
		three := (num \\ 1000) troisChiffresDnominateur.
		num := num // 1000.
		three isEmpty ifFalse: [
			answer isEmpty ifFalse: [
				answer := ' ',answer
			].
			answer := three,(mils at: milCount),answer.
		].
		milCount := milCount + 1.
	].
	^minus,answer! !

!Integer methodsFor: '*MathsOntologie-printing' stamp: 'AlainBusser 10/26/2012 20:41'!
commeFraction

	^self asFraction.! !

!Integer methodsFor: '*MathsOntologie' stamp: 'AlainBusser 10/26/2012 18:28'!
diviseurs
	"rpond les diviseurs du nombre placs dans un tableau" 

	^(1 jusque: self) choisis: [ :d | self \\ d = 0].! !

!Integer methodsFor: '*MathsOntologie-printing' stamp: 'AlainBusser 10/26/2012 20:41'!
enChiffresRomains

	^self printStringRoman.! !

!Integer methodsFor: '*MathsOntologie-testing' stamp: 'AlainBusser 11/21/2012 11:31'!
estDivisiblePar: unEntier

	^(self \\ unEntier) =0.! !

!Integer methodsFor: '*MathsOntologie-testing' stamp: 'AlainBusser 11/21/2012 11:30'!
estPremier

	^self isPrime.! !

!Integer methodsFor: '*MathsOntologie-testing' stamp: 'AlainBusser 11/21/2012 11:30'!
estPremierAvec: unEntier

	^(self pgcd: unEntier) = 1.! !

!Integer methodsFor: '*MathsOntologie-testing' stamp: 'AlainBusser 11/21/2012 11:29'!
estProbablementPremier

	^self isProbablyPrime.! !

!Integer methodsFor: '*MathsOntologie-testing' stamp: 'AlainBusser 11/21/2012 11:34'!
estUnCarr
	
	^(self auCarr estEntier).! !

!Integer methodsFor: '*MathsOntologie' stamp: 'AlainBusser 10/18/2012 17:30'!
extrait: unEntier

	^self take: unEntier.! !

!Integer methodsFor: '*MathsOntologie' stamp: 'AlainBusser 10/24/2012 19:03'!
facteursPremiers
	"met les facteurs premiers dans un sac"

	| sac n diviseur |
	sac := #() commeSac.
	n := self.
	diviseur := 2.
	[ diviseur <= n] tantQueVrai: [
		[n \\ diviseur =0] tantQueVrai: [
			sac ajoute: diviseur.
			n := n // diviseur.
		].
		(diviseur=2) siVrai: [
			diviseur := 3.
			] siFaux: [
			diviseur := diviseur+2.
			]
	].
	^sac tri.! !

!Integer methodsFor: '*MathsOntologie' stamp: 'AlainBusser 10/18/2012 17:25'!
factorielle

	^self factorial.! !

!Integer methodsFor: '*MathsOntologie' stamp: 'AlainBusser 10/18/2012 17:07'!
foisRpte: unBloc

	^self timesRepeat: unBloc.! !

!Integer methodsFor: '*MathsOntologie' stamp: 'AlainBusser 10/18/2012 17:11'!
inverseModulo: unEntier

	^self reciprocalModulo: unEntier.! !

!Integer methodsFor: '*MathsOntologie' stamp: 'AlainBusser 10/24/2012 15:26'!
modulo: unEntier

	^self \\ unEntier.! !

!Integer methodsFor: '*MathsOntologie' stamp: 'AlainBusser 10/18/2012 17:23'!
nombreDeChiffres

	^self numberOfDigits.! !

!Integer methodsFor: '*MathsOntologie' stamp: 'AlainBusser 10/18/2012 17:23'!
nombreDeChiffresEnBase: uneBase

	^self numberOfDigitsInBase: uneBase.! !

!Integer methodsFor: '*MathsOntologie' stamp: 'AlainBusser 11/6/2012 18:17'!
parmi: total

	^(total take: self).! !

!Integer methodsFor: '*MathsOntologie' stamp: 'AlainBusser 10/18/2012 17:24'!
pgcd: unEntier

	^self gcd: unEntier.! !

!Integer methodsFor: '*MathsOntologie' stamp: 'AlainBusser 10/18/2012 17:24'!
ppcm: unEntier

	^self lcm: unEntier.! !

!Integer methodsFor: '*MathsOntologie' stamp: 'AlainBusser 10/27/2012 14:58'!
prcdent
	"dcrmente un entier"

	^self - 1.! !

!Integer methodsFor: '*MathsOntologie' stamp: 'AlainBusser 10/18/2012 17:13'!
puissance: exp modulo: unEntier

	^self raisedTo: exp modulo: unEntier.! !

!Integer methodsFor: '*MathsOntologie' stamp: 'AlainBusser 10/27/2012 14:58'!
suivant
	"incrmente un entier"

	^self + 1.! !

!Time methodsFor: '*MathsOntologie' stamp: 'AlainBusser 11/8/2012 19:59'!
commeDate
	
	^self asDateAndTime.! !

!Boolean methodsFor: '*MathsOntologie' stamp: 'AlainBusser 10/26/2012 18:04'!
contraire
	"ngation boolenne"
	
	^self not.! !

!Boolean methodsFor: '*MathsOntologie' stamp: 'AlainBusser 10/15/2012 21:39'!
et: UnBloc
	"et au lieu de and"

	^self and: UnBloc.! !

!Boolean methodsFor: '*MathsOntologie' stamp: 'AlainBusser 10/15/2012 21:40'!
ou: UnBloc
	"ou au lieu de or"

	^self or: UnBloc.! !

!Boolean methodsFor: '*MathsOntologie' stamp: 'AlainBusser 10/15/2012 21:48'!
siFaux: UnBloc
	"test ngatif"

	^self ifFalse: UnBloc.! !

!Boolean methodsFor: '*MathsOntologie' stamp: 'AlainBusser 10/28/2012 17:30'!
siFaux: leBlocDuFaux siVrai: leBlocDuVrai
	"test alternatif"

	^self ifFalse: leBlocDuFaux ifTrue: leBlocDuVrai.! !

!Boolean methodsFor: '*MathsOntologie' stamp: 'AlainBusser 10/15/2012 21:47'!
siVrai: UnBloc
	"test positif"

	^self ifTrue: UnBloc.! !

!Boolean methodsFor: '*MathsOntologie' stamp: 'AlainBusser 10/15/2012 21:51'!
siVrai: leBlocDuVrai siFaux: leBlocDuFaux
	"test alternatif"

	^self ifTrue: leBlocDuVrai ifFalse: leBlocDuFaux.! !

!Fraction methodsFor: '*MathsOntologie-printing' stamp: 'AlainBusser 10/27/2012 14:35'!
avecDesMots

	| t q |
	q := #('unime' 'demi' 'tiers' 'quart').
	t := self numrateur avecDesMots.
	(self dnominateur > 1) siVrai: [
		t := t,' '.
		(self dnominateur < 5) siVrai: [
			t := t,(q en: self dnominateur).
			]
		siFaux: [
			t := t,(self dnominateur avecDesMotsDn),'ime'.
			].
		(self numrateur > 1 et: (self dnominateur =3) contraire) siVrai: [
			t := t,'s'.
			]
		].
	^t.! !

!Fraction methodsFor: '*MathsOntologie-printing' stamp: 'AlainBusser 10/27/2012 14:34'!
commePari
	"rpond la fraction comme probabilit"

	| c |
	c := self numrateur asString.
	(self numrateur < 2) siVrai: [
		c := c,' chance contre '.
		] siFaux:[
		c := c,' chances contre '.
		].
	c := c,(self dnominateur - self numrateur) asString.
	^c! !

!Fraction methodsFor: '*MathsOntologie-printing' stamp: 'AlainBusser 10/27/2012 14:34'!
commeProba
	"rpond la fraction comme probabilit"

	| c |
	c := self numrateur asString.
	(self numrateur < 2) siVrai: [
		c := c,' chance sur '.
		] siFaux:[
		c := c,' chances sur '.
		].
	c := c,self dnominateur asString.
	^c! !

!Fraction methodsFor: '*MathsOntologie' stamp: 'AlainBusser 10/25/2012 18:45'!
de: unNombre

	^self * unNombre.! !

!Fraction methodsFor: '*MathsOntologie' stamp: 'AlainBusser 10/18/2012 17:02'!
dnominateur

	^self denominator.! !

!Fraction methodsFor: '*MathsOntologie' stamp: 'AlainBusser 10/18/2012 17:04'!
estUnePuissanceDe2

	^self isPowerOfTwo.! !

!Fraction methodsFor: '*MathsOntologie' stamp: 'AlainBusser 10/18/2012 17:02'!
numrateur

	^self numerator.! !

!Fraction methodsFor: '*MathsOntologie' stamp: 'AlainBusser 10/18/2012 17:01'!
rduite

	^self reduced.! !

!Fraction methodsFor: '*MathsOntologie-printing' stamp: 'AlainBusser 10/27/2012 14:33'!
Lancienne
	"rpond la fraction  l'ancienne, avec partie entire"

	| a b |
	a := self partieEntire.
	b := self partieFractionnaire.
	^(a asString),'+',(b asString).! !

!Fraction methodsFor: '*MathsOntologie-printing' stamp: 'AlainBusser 10/27/2012 14:33'!
Lgyptienne
	"rpond la fraction comme somme de fractions gyptiennes
	soit de numrateurs 1;
	algorithme de Fibonacci-Sylvester"

	| liste b c chaine |
	liste := #() commeCollectionOrdonne.
	liste ajoute: self partieEntire.
	b := self partieFractionnaire.
	[b numrateur > 1] tantQueVrai: [
		c := (b inverse partieEntire + 1) inverse.
		b := b-c.
		liste ajoute: c.
	].
	liste ajoute: b.
	chaine := (liste commeTableau en: 1) asString.
	liste := liste retireTousTelsQue: [ :n | n isInteger].
	liste := liste commeTableau.
	liste fais: [ :elt | chaine := chaine,' + ',(elt asString)].
	
	^chaine.! !

!ThreadSafeTranscript methodsFor: '*MathsOntologie' stamp: 'AlainBusser 10/19/2012 10:53'!
affiche: unObjet

	^self crShow: unObjet.! !

!ThreadSafeTranscript methodsFor: '*MathsOntologie' stamp: 'AlainBusser 10/19/2012 10:53'!
efface

	^self clear.! !

!ThreadSafeTranscript methodsFor: '*MathsOntologie' stamp: 'AlainBusser 10/19/2012 10:47'!
espace

	^self space.! !

!ThreadSafeTranscript methodsFor: '*MathsOntologie' stamp: 'AlainBusser 10/19/2012 10:48'!
montre: unObjet

	^self show: unObjet.! !

Object subclass: #Interactif
	instanceVariableNames: 'contenu'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MathsOntologie'!

!Interactif class methodsFor: 'as yet unclassified' stamp: 'AlainBusser 12/9/2012 10:50'!
initialize
	
	super initialize.! !

!Interactif methodsFor: 'as yet unclassified' stamp: 'AlainBusser 12/9/2012 11:31'!
entrerChoix: listeDeChoix
	
	contenu := listeDeChoix en: 1.
	contenu := listeDeChoix en: (UIManager default chooseFrom: listeDeChoix).
	^contenu.! !

!Interactif methodsFor: 'as yet unclassified' stamp: 'AlainBusser 12/9/2012 11:37'!
entrerChoix: listeDeChoix question: uneQuestion
	
	contenu := listeDeChoix en: 1.
	contenu := listeDeChoix en: (UIManager default chooseFrom: listeDeChoix message: uneQuestion).
	^contenu.! !

!Interactif methodsFor: 'as yet unclassified' stamp: 'AlainBusser 12/9/2012 10:58'!
entrerNombre: prompt
	
	contenu := '3.141592654'.
	contenu := (UIManager default request: prompt initialAnswer: contenu) commeNombre.
	^contenu.! !

!Interactif methodsFor: 'as yet unclassified' stamp: 'AlainBusser 12/9/2012 10:57'!
entrerTexte: prompt
	
	contenu := 'Remplacer ceci par le texte souhait'.
	contenu := UIManager default request: prompt initialAnswer: contenu.
	^contenu.! !

!Object methodsFor: '*MathsOntologie' stamp: 'AlainBusser 10/26/2012 18:06'!
commeTexte
	"affichage"

	^self asString.! !

!Object methodsFor: '*MathsOntologie' stamp: 'AlainBusser 12/1/2012 14:46'!
estComplexe

	^false.! !

!Collection methodsFor: '*MathsOntologie-modification' stamp: 'AlainBusser 10/19/2012 11:42'!
ajoute: unObjet

	^self add: unObjet.! !

!Collection methodsFor: '*MathsOntologie-modification' stamp: 'AlainBusser 12/3/2012 21:38'!
ajoute: unObjet fois: unEntier

	unEntier foisRpte: [self ajoute: unObjet].! !

!Collection methodsFor: '*MathsOntologie-modification' stamp: 'AlainBusser 10/19/2012 11:45'!
ajouteAuBesoin: unObjet

	^self addIfNotPresent: unObjet.! !

!Collection methodsFor: '*MathsOntologie-modification' stamp: 'AlainBusser 10/19/2012 11:44'!
ajouteTout: uneCollection

	^self addAll: uneCollection.! !

!Collection methodsFor: '*MathsOntologie-statistiques' stamp: 'AlainBusser 10/20/2012 11:36'!
arrondis

	^self rounded.! !

!Collection methodsFor: '*MathsOntologie-statistiques' stamp: 'AlainBusser 10/20/2012 11:34'!
auCarr

	^self squared.! !

!Collection methodsFor: '*MathsOntologie-statistiques' stamp: 'AlainBusser 10/19/2012 11:51'!
auHasard

	^self atRandom.! !

!Collection methodsFor: '*MathsOntologie-boucles' stamp: 'AlainBusser 10/20/2012 11:54'!
aucunNeVrifie: unBloc

	^self noneSatisfy: unBloc.! !

!Collection methodsFor: '*MathsOntologie-boucles' stamp: 'AlainBusser 10/24/2012 16:49'!
choisis: unBloc
	
	^self select: unBloc.! !

!Collection methodsFor: '*MathsOntologie-boucles' stamp: 'AlainBusser 10/26/2012 18:19'!
choisis: bloc ensuite: unBloc
	
	^self select: bloc thenDo: unBloc.! !

!Collection methodsFor: '*MathsOntologie-conversion' stamp: 'AlainBusser 10/19/2012 11:55'!
commeCollectionOrdonne

	^self asOrderedCollection.! !

!Collection methodsFor: '*MathsOntologie-conversion' stamp: 'AlainBusser 10/19/2012 11:55'!
commeCollectionTrie

	^self asSortedCollection.! !

!Collection methodsFor: '*MathsOntologie-conversion' stamp: 'AlainBusser 10/19/2012 11:56'!
commeDictionnaire

	^self asDictionary.! !

!Collection methodsFor: '*MathsOntologie-conversion' stamp: 'AlainBusser 10/19/2012 11:54'!
commeEnsemble

	^self asSet.! !

!Collection methodsFor: '*MathsOntologie-conversion' stamp: 'AlainBusser 10/19/2012 11:57'!
commeSac

	^self asBag.! !

!Collection methodsFor: '*MathsOntologie-conversion' stamp: 'AlainBusser 10/19/2012 11:57'!
commeTableau

	^self asArray.! !

!Collection methodsFor: '*MathsOntologie-boucles' stamp: 'AlainBusser 10/24/2012 16:50'!
compte: unBloc
	
	^self count: unBloc.! !

!Collection methodsFor: '*MathsOntologie-testing' stamp: 'AlainBusser 11/10/2012 11:47'!
contient: unObjet
	
	^(self includes: unObjet).! !

!Collection methodsFor: '*MathsOntologie-statistiques' stamp: 'AlainBusser 10/20/2012 11:39'!
cosinus
	
	^self degreeCos.! !

!Collection methodsFor: '*MathsOntologie-statistiques' stamp: 'AlainBusser 11/21/2012 14:24'!
dessineHistogramme
	"dessine l'histogramme"

	| diagramme trait n dx nom horizontal mech |
	mech := self values max.
	diagramme := Morph new color: (Color yellow alpha: 0.2).
	diagramme extent: 220@180.
	diagramme borderWidth: 2.
	diagramme setBorderStyle: #complexRaised.
	trait := Morph new color: Color black.
	trait extent: 200@1.
	trait position: 10@160.
	diagramme addMorph: trait.
	n := self keys taille suivant.
	dx := (180/n).
	n := 0.
		horizontal := TransformationMorph new.
		horizontal angle: 0.
		horizontal position: 25@160.
		diagramme addMorph: horizontal.
		self keys tri fais: [ :clef |
			nom := clef asMorph.
			nom position: n*dx@0.
			nom forwardDirection: 1.
			horizontal addMorph: nom.
			trait := Morph new color: (Color blue alpha: 0.5).
			trait position: (25+(n*dx))@(160-(150*(self at: clef)/mech) floor).
			trait extent: dx@(150*(self at: clef)/mech ceiling).
			trait borderWidth: 1.
			trait setBorderStyle: #complexRaised.
			diagramme addMorph: trait.
			n := n suivant.
		].
	diagramme openInWorld.
	! !

!Collection methodsFor: '*MathsOntologie-statistiques' stamp: 'AlainBusser 12/9/2012 09:57'!
diagrammeBatons
	"dessine le diagramme en btons"

	| diagramme trait n dx nom vertical mech |
	mech := self values max.
	diagramme := Morph new color: (Color yellow alpha: 0.2).
	diagramme extent: 220@180.
	diagramme borderWidth: 2.
	diagramme setBorderStyle: #complexRaised.
	trait := Morph new color: Color black.
	trait extent: 200@1.
	trait position: 10@100.
	diagramme addMorph: trait.
	n := self keys taille suivant.
	dx := (180/n).
	n := 0.
		vertical := TransformationMorph new.
		vertical angle: (Float pi / 2 negated).
		vertical position: 35@100.
		diagramme addMorph: vertical.
		self keys fais: [ :clef |
			nom := clef asMorph.
			nom position: 0@(n*dx negated).
			nom forwardDirection: 1.
			vertical addMorph: nom.
			trait := Morph new color: (Color blue alpha: 0.5).
			trait position: (25+(n*dx))@(100-(96*(self at: clef)/mech) floor).
			trait extent: 4@(96*(self at: clef)/mech).
			trait borderWidth: 2.
			trait setBorderStyle: #complexRaised.
			diagramme addMorph: trait.
			n := n suivant.
		].
	diagramme openInWorld.
! !

!Collection methodsFor: '*MathsOntologie-statistiques' stamp: 'AlainBusser 12/9/2012 09:52'!
diagrammeBatonsTri
	"dessine le diagramme en btons"

	| diagramme trait n dx nom vertical mech |
	mech := self values max.
	diagramme := Morph new color: (Color yellow alpha: 0.2).
	diagramme extent: 220@180.
	diagramme borderWidth: 2.
	diagramme setBorderStyle: #complexRaised.
	trait := Morph new color: Color black.
	trait extent: 200@1.
	trait position: 10@100.
	diagramme addMorph: trait.
	n := self keys taille suivant.
	dx := (180/n).
	n := 0.
		vertical := TransformationMorph new.
		vertical angle: (Float pi / 2 negated).
		vertical position: 35@100.
		diagramme addMorph: vertical.
		self keys tri fais: [ :clef |
			nom := clef asMorph.
			nom position: 0@(n*dx negated).
			nom forwardDirection: 1.
			vertical addMorph: nom.
			trait := Morph new color: (Color blue alpha: 0.5).
			trait position: (25+(n*dx))@(100-(96*(self at: clef)/mech) floor).
			trait extent: 4@(96*(self at: clef)/mech).
			trait borderWidth: 2.
			trait setBorderStyle: #complexRaised.
			diagramme addMorph: trait.
			n := n suivant.
		].
	diagramme openInWorld.
! !

!Collection methodsFor: '*MathsOntologie-statistiques' stamp: 'AlainBusser 11/8/2012 18:25'!
effectifs
	"construit une table d'effectifs"

	| table cls |
	table := Dictionary new.
	cls := self asSet.
	cls do: [ :n | table at: n put: (self count: [ :t | t=n])].
	^table.! !

!Collection methodsFor: '*MathsOntologie-statistiques' stamp: 'AlainBusser 11/21/2012 12:53'!
effectifsEnClasses: unEntier
	"construit une table pour histogramme"

	| table cls h |
	h := self tendue / unEntier.
	table := Dictionary new.
	cls := self min to: (self max - 0.000001) by: h.
	cls do: [ :n | table at: n put: (self count: [ :t | (t>=n) and: [t<(n+h)]])].
	^table.! !

!Collection methodsFor: '*MathsOntologie-testing' stamp: 'AlainBusser 10/18/2012 18:01'!
estVide

	^self isEmpty.! !

!Collection methodsFor: '*MathsOntologie-boucles' stamp: 'AlainBusser 10/24/2012 16:50'!
exclus: unBloc
	
	^self reject: unBloc.! !

!Collection methodsFor: '*MathsOntologie-boucles' stamp: 'AlainBusser 10/24/2012 16:50'!
exclus: bloc ensuite: unBloc
	
	^self reject: bloc thenDo: unBloc.! !

!Collection methodsFor: '*MathsOntologie-boucles' stamp: 'AlainBusser 10/26/2012 18:19'!
fais: unBloc
	
	^self do: unBloc.! !

!Collection methodsFor: '*MathsOntologie-statistiques' stamp: 'AlainBusser 11/8/2012 18:31'!
frquences
	"construit une table de frquences"

	| table cls total |
	total := self size.
	table := Dictionary new.
	cls := self asSet.
	cls do: [ :n | table at: n put: ((self count: [ :t | t=n])/total)].
	^table.! !

!Collection methodsFor: '*MathsOntologie-statistiques' stamp: 'AlainBusser 11/21/2012 13:18'!
frquencesEnClasses: unEntier
	"construit une table pour histogramme"

	| table cls h total |
	total := self size.
	h := self tendue / unEntier.
	table := Dictionary new.
	cls := self min to: (self max - 0.000001) by: h.
	cls do: [ :n | table at: n put: ((self count: [ :t | (t>=n) and: [t<(n+h)]])/total)].
	^table.! !

!Collection methodsFor: '*MathsOntologie-boucles' stamp: 'AlainBusser 10/20/2012 11:59'!
groupsPar: unBloc

	^self groupedBy: unBloc.! !

!Collection methodsFor: '*MathsOntologie-boucles' stamp: 'AlainBusser 10/20/2012 11:58'!
groupsPar: unBloc telsQue: condition

	^self groupedBy: unBloc having: condition.! !

!Collection methodsFor: '*MathsOntologie-boucles' stamp: 'AlainBusser 10/24/2012 16:51'!
injecte: valeur dans: unBloc

	^self inject: valeur into: unBloc.! !

!Collection methodsFor: '*MathsOntologie-boucles' stamp: 'AlainBusser 10/20/2012 11:41'!
inter: uneCollection
	
	^self intersection: uneCollection.! !

!Collection methodsFor: '*MathsOntologie-statistiques' stamp: 'AlainBusser 10/20/2012 11:35'!
inverses

	^self reciprocal.! !

!Collection methodsFor: '*MathsOntologie-statistiques' stamp: 'AlainBusser 10/20/2012 11:30'!
moyenne

	^self average.! !

!Collection methodsFor: '*MathsOntologie-statistiques' stamp: 'AlainBusser 10/19/2012 11:40'!
mdiane

	^self median.! !

!Collection methodsFor: '*MathsOntologie-statistiques' stamp: 'AlainBusser 10/20/2012 11:35'!
opposs

	^self negated.! !

!Collection methodsFor: '*MathsOntologie-boucles' stamp: 'AlainBusser 10/26/2012 18:19'!
picore: unBloc
	
	^self collect: unBloc.! !

!Collection methodsFor: '*MathsOntologie-boucles' stamp: 'AlainBusser 10/26/2012 18:18'!
picore: unBloc puisChoisis: critre
	
	^self collect: unBloc thenSelect: critre.! !

!Collection methodsFor: '*MathsOntologie-boucles' stamp: 'AlainBusser 10/26/2012 18:18'!
picore: unBloc puisFais: autreBloc
	
	^self collect: unBloc thenDo: autreBloc.! !

!Collection methodsFor: '*MathsOntologie-boucles' stamp: 'AlainBusser 10/26/2012 18:18'!
picore: unBloc vers: uneCollection
	
	^self collect: unBloc into: uneCollection.! !

!Collection methodsFor: '*MathsOntologie-statistiques' stamp: 'AlainBusser 11/8/2012 17:25'!
premierQuartile

	^(self commeCollectionTrie Q1).! !

!Collection methodsFor: '*MathsOntologie-statistiques' stamp: 'AlainBusser 10/20/2012 11:31'!
puissance: unExposant

	^self raisedTo: unExposant.! !

!Collection methodsFor: '*MathsOntologie-statistiques' stamp: 'AlainBusser 10/20/2012 11:34'!
racines

	^self sqrt.! !

!Collection methodsFor: '*MathsOntologie-boucles' stamp: 'AlainBusser 10/24/2012 16:51'!
regroupe: unBloc
	
	^self gather: unBloc.! !

!Collection methodsFor: '*MathsOntologie-modification' stamp: 'AlainBusser 10/19/2012 11:08'!
retire: unBloc

	^self remove: unBloc.! !

!Collection methodsFor: '*MathsOntologie-modification' stamp: 'AlainBusser 10/19/2012 11:07'!
retireTousTelsQue: unBloc

	^self removeAllSuchThat: unBloc.! !

!Collection methodsFor: '*MathsOntologie-modification' stamp: 'AlainBusser 10/19/2012 11:22'!
retireTout

	^self removeAll.! !

!Collection methodsFor: '*MathsOntologie-modification' stamp: 'AlainBusser 10/19/2012 11:22'!
retireToutCeQuiEstDans: uneCollection

	^self removeAll: uneCollection.! !

!Collection methodsFor: '*MathsOntologie-boucles' stamp: 'AlainBusser 10/26/2012 18:17'!
rduis: unBloc

	^self reduce: unBloc.! !

!Collection methodsFor: '*MathsOntologie-statistiques' stamp: 'AlainBusser 10/20/2012 11:39'!
sinus
	
	^self degreeSin.! !

!Collection methodsFor: '*MathsOntologie-statistiques' stamp: 'AlainBusser 10/20/2012 11:32'!
somme

	^self sum.! !

!Collection methodsFor: '*MathsOntologie-statistiques' stamp: 'AlainBusser 10/19/2012 11:50'!
taille

	^self size.! !

!Collection methodsFor: '*MathsOntologie-statistiques' stamp: 'AlainBusser 10/20/2012 11:32'!
total

	^self sum.! !

!Collection methodsFor: '*MathsOntologie-boucles' stamp: 'AlainBusser 10/20/2012 12:19'!
tousVrifient: unBloc

	^self allSatisfy: unBloc.! !

!Collection methodsFor: '*MathsOntologie-modification' stamp: 'AlainBusser 10/19/2012 11:53'!
tri
	
	^self sorted.! !

!Collection methodsFor: '*MathsOntologie-boucles' stamp: 'AlainBusser 10/20/2012 11:45'!
triSelon: unBloc
	
	^self sorted: unBloc.! !

!Collection methodsFor: '*MathsOntologie-statistiques' stamp: 'AlainBusser 11/8/2012 17:26'!
troisimeQuartile

	^self commeCollectionTrie Q3.! !

!Collection methodsFor: '*MathsOntologie-boucles' stamp: 'AlainBusser 10/20/2012 12:19'!
unVrifie: unBloc

	^self anySatisfy: unBloc.! !

!Collection methodsFor: '*MathsOntologie-statistiques' stamp: 'AlainBusser 10/19/2012 11:40'!
cartType

	^self stdev.! !

!Collection methodsFor: '*MathsOntologie-statistiques' stamp: 'AlainBusser 10/20/2012 11:32'!
tendue

	^self range.! !

!String methodsFor: '*MathsOntologie' stamp: 'AlainBusser 12/9/2012 08:13'!
commeNombre
	
	^(self asNumber).! !

!String methodsFor: '*MathsOntologie' stamp: 'AlainBusser 12/1/2012 13:29'!
contient: unString

	^self includesSubString: unString.! !

!String methodsFor: '*MathsOntologie' stamp: 'AlainBusser 12/1/2012 13:20'!
enMajuscules

	^self asUppercase.! !

!String methodsFor: '*MathsOntologie' stamp: 'AlainBusser 12/1/2012 13:23'!
enMinuscules

	^self asLowercase.! !

!String methodsFor: '*MathsOntologie' stamp: 'AlainBusser 12/1/2012 13:26'!
estCombienDeFoisDans: unString

	^self howManyMatch: unString.! !

!String methodsFor: '*MathsOntologie' stamp: 'AlainBusser 12/1/2012 13:25'!
estDans: unTexte
	
	^self match: unTexte.! !

!String methodsFor: '*MathsOntologie' stamp: 'AlainBusser 12/1/2012 13:12'!
formate: uneCollection
	
	^(self format: uneCollection).! !

!String methodsFor: '*MathsOntologie' stamp: 'AlainBusser 12/1/2012 13:19'!
lettrine

	^self capitalized.! !

!String methodsFor: '*MathsOntologie' stamp: 'AlainBusser 12/1/2012 13:15'!
traduitPar: tableau
	
	^self translateBy: tableau.! !
Interactif initialize!
Complexe initialize!
